<template>
  <div class="taskListBox">
    <div class="header">
      <div class="title">
        <img src="../../assets/images/mount_head.png" />
        <div class="font">{{ $t('common.任务库') }}</div>
      </div>
    </div>
    <el-form class="task-main" label-width="60px">
      <el-form-item :label="$t('common.任务库')">
        <el-cascader
          filterable
          popper-class="mmc"
          size="mini"
          class
          style="width: 100%"
          v-model="selectedTaskId"
          :options="taskListAll"
          clearable
          :show-all-levels="false"
          :placeholder="$t('common.请选择任务')"
          :props="{
              children: 'children',
              label: 'name',
              value: 'id',
            }"
          @change="onChangeTask"
        >
          <template slot-scope="{ data }">
            <el-tooltip class="item" effect="dark" :content="data.name" placement="top-start">
              <span>{{ data.name }}</span>
            </el-tooltip>
          </template>
        </el-cascader>
      </el-form-item>
      <el-form-item :label="$t('common.航线')">
        <el-tooltip :content="$t('common.航线名称')" placement="top">
          <el-input
            v-if="isSelectTask || selectedAirway.id !== -1"
            disabled
            v-model="selectedAirway.name"
            :placeholder="$t('common.请选择航线')"
            class
            style="width: 100%"
            size="mini"
          ></el-input>
          <el-button v-else class="select-airway__btn" @click="showFlywayDialog = true">{{ $t('common.选择航线') }}</el-button>
        </el-tooltip>
      </el-form-item>
      <div class="btn" @click="onStartTask" v-hover>{{ $t('common.一键任务') }}</div>
      <div class>
        <span class="btn__add-line" @click="showAirwayEdit = true">
          <span class="f8"></span> {{ $t('common.创建航线') }}
        </span>
      </div>
    </el-form>
    <LineList v-if="showFlywayDialog" @close="showFlywayDialog = false;" @change="onChangeLine"></LineList>
    <AirwayEdit v-if="showAirwayEdit" @close="showAirwayEdit = false"></AirwayEdit>
  </div>
</template>
<script>
import LineList from "./components/lineList";
import { Utils } from "../../../../../../../../lib/cesium";
import { mapState, mapActions } from "vuex";
import { AirLine } from "../../../../../../../../api";
import AirwayEdit from './components/airwayEdit';

const airwayEntities = []; // 航线实体
let point_entity = null;

export default {
  name: "taskList",
  components: { LineList, AirwayEdit },
  props: {},
  inject: ["rootNode", "bus"],
  data() {
    return {
      // 选择的任务id
      selectedTaskId: [],
      // 选择的航线
      selectedAirway: {
        name: "",
        id: -1,
      },
      // 航线选择窗口
      showFlywayDialog: false,
      // 创建航线窗口
      showAirwayEdit: false
    };
  },
  computed: {
    ...mapState("MMCFlightControlCenter", ["cesiumViewer", "useSTLAirway"]),
    ...mapState("MMCFlightControlCenter/uav", ["taskList", "uav"]),
    taskListAll() {
      return [{ name: this.$t('common.选择航线自动生成任务'), id: -1 }, ...this.taskList];
    },
    /**
     * 是否选择任务
     */
    isSelectTask() {
      return this.selectedTaskId[0] && this.selectedTaskId[0] !== -1;
    },
    /**
     * 选择的任务数据
     */
    selectedTask() {
      let find = this.taskList.find((item) => {
        return item.id === this.selectedTaskId[this.selectedTaskId.length - 1];
      });
      return find;
    },
  },
  watch: {
    selectedAirway() {
      this.clearAirwayEntities();
      if (this.selectedAirway.id !== -1) {
        try {
          let airway = this.selectedAirway.content;
          this.createAirwayEntities({
            polyline: airway,
            id: airway.id,
          });
        } catch (e) {
          console.log("绘制航线失败", e);
        }
      }
    },
  },
  async created() {
    this.bus.$on("startTask", this.onStartTask);
  },
  beforeDestroy() {
    this.bus.$off("startTask", this.onStartTask);
    this.clearAirwayEntities();
  },
  methods: {
    ...mapActions("MMCFlightControlCenter", [
      "createAirwayEntities",
      "clearAirwayEntities",
      "apiPointsToFKZXPoints",
    ]),
    ...mapActions("MMCFlightControlCenter/uav", ["isTakeOver"]),
    /**
     * 更改航线事件
     */
    onChangeLine(data) {
      this.selectedAirway = data;
      this.rootNode.$emit("taskAdd", {
        airway: data,
        callback: ({ id }) => {
          // 返回新增任务后的任务id
          this.selectedTaskId = id;
        },
      });
    },
    /**
     * 一键任务事件
     */
    async onStartTask() {
      // 判断是否已接管
      if (!(await this.isTakeOver())) {
        this.$message.warning(this.$t('common.请先接管设备'));
        return;
      }

      // 判断是否选择了航线
      if (this.selectedAirway.id === -1) {
        this.$message.warning(this.$t('common.请选择航线'));
        return;
      }
      try {
        await this.$confirm(this.$t('common.请确认是否进行一键任务操作?'), this.$t('common.安全确认'), {
          cancelButtonText: this.$t('common.取消'),
          confirmButtonText: this.$t('common.确定'),
          customClass: "uav_controlPane",
          showClose: false,
        });
        this.$store.commit("MMCFlightControlCenter/uav/setState", {
          key: "airlineData",
          value: this.selectedAirway,
        });
        this.$store.dispatch("MMCFlightControlCenter/uav/takeOff", {
          callback: (status) => {
            if (status) {
              this.$message.success(this.$t('common.一键任务指令发送成功'));
            } else {
              this.$message.error(this.$t('common.一键任务指令发送失败'));
            }
          },
        });
        this.rootNode.$emit("taskStart", {
          uav: this.uav,
          task: this.selectedTask,
          airway: this.selectedAirway,
        });
      } catch (e) {}
    },
    /**
     * 更改任务事件
     */
    async onChangeTask() {
      if (!this.selectedTask?.airwayId) {
        this.selectedAirway = {
          name: "",
          id: -1,
        };
      } else if (this.useSTLAirway) {
        let res = await AirLine.routeDetail({
          id: this.selectedTask?.airwayId,
        });
        if (res.code === 0) {
          let content = await apiPointsToFKZXPoints({
            list: res.data.linePointRespVOS,
            actionListKey: "pointActionRespVOS",
          });
          this.selectedAirway = {
            name: res.data.flightName,
            id: res.data.id,
            content,
          };
        }
      } else {
        this.rootNode.$emit("airwayGet", {
          airwayId: this.selectedTask?.airwayId,
          callback: (airway) => {
            this.selectedAirway = airway;
          },
        });
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.taskListBox {
  min-height: 254px;
  width:350px;
  background: #222222;
  border-radius: 12px;
  transition: 0.3s;
  display: flex;
  flex-direction: column;

  .header {
    flex-shrink: 0;
    display: flex;
    justify-content: space-between;
    height: 32px;
    background: #3c3c3c;
    border-radius: 12px 12px 0px 0px;
    .title {
      display: flex;
      align-items: center;
      margin-left: 10px;
      .font {
        font-size: 20px;
        font-family: YouSheBiaoTiHei;
        color: #14faff;
        line-height: 26px;
        text-shadow: 0px 1px 1px rgba(2, 32, 56, 0.2);
        background-image: -webkit-linear-gradient(
          right,
          #e3aa77,
          #f5cda9,
          #f9ecd3,
          #fcdbb1,
          #edb07a
        );
        -webkit-background-clip: text;
        -webkit-text-fill-color: transparent;
      }
    }
    .active {
      background-image: linear-gradient(
        180deg,
        #9198ff 0%,
        rgba(45, 81, 153, 0.22) 40%,
        #05091a 100%
      );
      border: 1px solid #70daf9;
      box-shadow: inset 0 0 10px 2px #3f9dff;
      font-family: MicrosoftYaHei-Bold;
      font-size: 14px;
      color: #70daf9;
      letter-spacing: 0;
      font-weight: 700;
    }

    .default {
      background-image: linear-gradient(
        180deg,
        #9198ff 0%,
        rgba(45, 81, 153, 0.22) 40%,
        #05091a 100%
      );
      border: 1px solid #70daf9;
      font-family: MicrosoftYaHei-Bold;
      font-size: 14px;
      color: rgba(112, 218, 249, 0.5);
      letter-spacing: 0;
      font-weight: 700;
    }
  }
  .task-main::v-deep {
    flex: auto;
    padding: 38px 16px 16px;
    position: relative;
    display: flex;
    flex-direction: column;

    .el-form-item__label {
      color: #fff;
    }

    .btn__add-line {
      position: absolute;
      bottom: 20px;
      right: 20px;
      font-size: 10px;
      color: #43deff;
      cursor: pointer;
    }
  }

  .btn {
    width: 122px;
    height: 32px;
    text-align: center;
    line-height: 32px;
    margin: 0 auto;
    color: #fff;
    background: #3388ff;
    font-family: SourceHanSansCN, SourceHanSansCN;
    font-weight: 400;
    font-size: 14px;
    cursor: pointer;
  }
}
.select-airway__btn {
  width: 100%;
  height: 30px;
  padding: 0;
}
</style>
